(* $Id: godi_getopt.mli 744 2008-05-19 23:05:11Z gerd $ *)

(* This is a traditional getopt without long options *)

(* Note 1: Options with arguments must be written as "-s arg", not "-sarg".
   The latter style is discouraged anyway by POSIX.

   Note 2: Optional arguments are not supported, i.e. when you are free to pass
   "-s" or "-s arg".
 *)

type action =
  [ `Set of bool ref
  | `Clear of bool ref
  | `Unit of unit -> unit
  | `String of string -> unit
  | `Set_string of string ref
  | `End_of_switches
      (* e.g. [ "--", `End_of_switches, "  after -- no switches can follow"] *)
  | `Help
  ]


type spec = string * action * string
    (* ("-s", action, "comment"). The options must be one letter or one digit.
       Options without argument can be combined.
     *)

val parse : spec list -> (string -> unit) -> string -> unit
  (* Parses the arguments. Starts at Arg.current+1. The exception Arg.Bad is
     understood
   *)
